## spirv-tools 2019.1

=== external/CMakeLists.txt ===
# Copyright (c) 2015-2016 The Khronos Group Inc.
#
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

if (DEFINED SPIRV-Headers_SOURCE_DIR)
  # This allows flexible position of the SPIRV-Headers repo.
  set(SPIRV_HEADER_DIR ${SPIRV-Headers_SOURCE_DIR})
else()
  if (IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/SPIRV-Headers)
    set(SPIRV_HEADER_DIR ${CMAKE_CURRENT_SOURCE_DIR}/SPIRV-Headers)
  else()
    set(SPIRV_HEADER_DIR ${CMAKE_CURRENT_SOURCE_DIR}/spirv-headers)
  endif()
endif()

if (IS_DIRECTORY ${SPIRV_HEADER_DIR})
  set(SPIRV_HEADER_INCLUDE_DIR ${SPIRV_HEADER_DIR}/include PARENT_SCOPE)
else()
  message(FATAL_ERROR
    "SPIRV-Headers was not found - please checkout a copy under external/.")
endif()

if (NOT ${SPIRV_SKIP_TESTS})
  # Find gmock if we can. If it's not already configured, then try finding
  # it in external/googletest.
  if (TARGET gmock)
    message(STATUS "Google Mock already configured")
  else()
    set(GMOCK_DIR ${CMAKE_CURRENT_SOURCE_DIR}/googletest/googlemock)
    if(EXISTS ${GMOCK_DIR})
      if(MSVC)
        # Our tests use ::testing::Combine.  Work around a compiler
        # detection problem in googletest, where that template is
        # accidentally disabled for VS 2017.
        # See https://github.com/google/googletest/issues/1352
        add_definitions(-DGTEST_HAS_COMBINE=1)
      endif()
      if(WIN32)
        option(gtest_force_shared_crt
          "Use shared (DLL) run-time lib even when Google Test is built as static lib."
          ON)
      endif()
      add_subdirectory(${GMOCK_DIR} EXCLUDE_FROM_ALL)
    endif()
  endif()
  if (TARGET gmock)
    set(GTEST_TARGETS
      gtest
      gtest_main
      gmock
      gmock_main
    )
    foreach(target ${GTEST_TARGETS})
      set_property(TARGET ${target} PROPERTY FOLDER GoogleTest)
    endforeach()
  endif()

  # Find Effcee and RE2, for testing.

  # First find RE2, since Effcee depends on it.
  # If already configured, then use that.  Otherwise, prefer to find it under 're2'
  # in this directory.
  if (NOT TARGET re2)
    # If we are configuring RE2, then turn off its testing.  It takes a long time and
    # does not add much value for us.  If an enclosing project configured RE2, then it
    # has already chosen whether to enable RE2 testing.
    set(RE2_BUILD_TESTING OFF CACHE STRING "Run RE2 Tests")
    if (NOT RE2_SOURCE_DIR)
      if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/re2)
	set(RE2_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/re2" CACHE STRING "RE2 source dir" )
      endif()
    endif()
  endif()

  if (NOT TARGET effcee)
    # Expect to find effcee in this directory.
    if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/effcee)
      # If we're configuring RE2 (via Effcee), then turn off RE2 testing.
      if (NOT TARGET re2)
	set(RE2_BUILD_TESTING OFF)
      endif()
      if (MSVC)
	# SPIRV-Tools uses the shared CRT with MSVC.  Tell Effcee to do the same.
	set(EFFCEE_ENABLE_SHARED_CRT ON)
      endif()
      add_subdirectory(effcee)
      set_property(TARGET effcee PROPERTY FOLDER Effcee)
      # Turn off warnings for effcee and re2
      set_property(TARGET effcee APPEND PROPERTY COMPILE_OPTIONS -w)
      set_property(TARGET re2 APPEND PROPERTY COMPILE_OPTIONS -w)
    endif()
  endif()
endif()

=== source/comp/CMakeLists.txt ===
# Copyright (c) 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

if(SPIRV_BUILD_COMPRESSION)
  add_library(SPIRV-Tools-comp
      bit_stream.cpp
      bit_stream.h
      huffman_codec.h
      markv_codec.cpp
      markv_codec.h
      markv.cpp
      markv.h
      markv_decoder.cpp
      markv_decoder.h
      markv_encoder.cpp
      markv_encoder.h
      markv_logger.h
      move_to_front.h
      move_to_front.cpp)

  spvtools_default_compile_options(SPIRV-Tools-comp)
  target_include_directories(SPIRV-Tools-comp
    PUBLIC ${spirv-tools_SOURCE_DIR}/include
    PUBLIC ${SPIRV_HEADER_INCLUDE_DIR}
    PRIVATE ${spirv-tools_BINARY_DIR}
  )

  target_link_libraries(SPIRV-Tools-comp
    PUBLIC ${SPIRV_TOOLS})

  set_property(TARGET SPIRV-Tools-comp PROPERTY FOLDER "SPIRV-Tools libraries")
  spvtools_check_symbol_exports(SPIRV-Tools-comp)

  if(ENABLE_SPIRV_TOOLS_INSTALL)
    install(TARGETS SPIRV-Tools-comp
      RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
      LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
      ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
  endif(ENABLE_SPIRV_TOOLS_INSTALL)

endif(SPIRV_BUILD_COMPRESSION)

=== source/reduce/CMakeLists.txt ===
# Copyright (c) 2018 Google LLC

# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
set(SPIRV_TOOLS_REDUCE_SOURCES
        change_operand_reduction_opportunity.h
        change_operand_to_undef_reduction_opportunity.h
        operand_to_const_reduction_pass.h
        operand_to_undef_reduction_pass.h
        operand_to_dominating_id_reduction_pass.h
        reducer.h
        reduction_opportunity.h
        reduction_pass.h
        reduction_util.h
        remove_instruction_reduction_opportunity.h
        remove_opname_instruction_reduction_pass.h
        remove_unreferenced_instruction_reduction_pass.h
        structured_loop_to_selection_reduction_opportunity.h
        structured_loop_to_selection_reduction_pass.h

        change_operand_reduction_opportunity.cpp
        change_operand_to_undef_reduction_opportunity.cpp
        operand_to_const_reduction_pass.cpp
        operand_to_undef_reduction_pass.cpp
        operand_to_dominating_id_reduction_pass.cpp
        reducer.cpp
        reduction_opportunity.cpp
        reduction_pass.cpp
        reduction_util.cpp
        remove_instruction_reduction_opportunity.cpp
        remove_unreferenced_instruction_reduction_pass.cpp
        remove_opname_instruction_reduction_pass.cpp
        structured_loop_to_selection_reduction_opportunity.cpp
        structured_loop_to_selection_reduction_pass.cpp
        )

if(MSVC)
  # Enable parallel builds across four cores for this lib
  add_definitions(/MP4)
endif()

spvtools_pch(SPIRV_TOOLS_REDUCE_SOURCES pch_source_reduce)

add_library(SPIRV-Tools-reduce ${SPIRV_TOOLS_REDUCE_SOURCES})

spvtools_default_compile_options(SPIRV-Tools-reduce)
target_include_directories(SPIRV-Tools-reduce
  PUBLIC ${spirv-tools_SOURCE_DIR}/include
  PUBLIC ${SPIRV_HEADER_INCLUDE_DIR}
  PRIVATE ${spirv-tools_BINARY_DIR}
)
# The reducer reuses a lot of functionality from the SPIRV-Tools library.
target_link_libraries(SPIRV-Tools-reduce
  PUBLIC ${SPIRV_TOOLS}
  PUBLIC SPIRV-Tools-opt)

set_property(TARGET SPIRV-Tools-reduce PROPERTY FOLDER "SPIRV-Tools libraries")
spvtools_check_symbol_exports(SPIRV-Tools-reduce)

if(ENABLE_SPIRV_TOOLS_INSTALL)
  install(TARGETS SPIRV-Tools-reduce
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif(ENABLE_SPIRV_TOOLS_INSTALL)

=== test/opt/CMakeLists.txt ===
# Copyright (c) 2016 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

add_subdirectory(dominator_tree)
add_subdirectory(loop_optimizations)

add_spvtools_unittest(TARGET opt
  SRCS aggressive_dead_code_elim_test.cpp
       assembly_builder_test.cpp
       block_merge_test.cpp
       ccp_test.cpp
       cfg_cleanup_test.cpp
       combine_access_chains_test.cpp
       common_uniform_elim_test.cpp
       compact_ids_test.cpp
       constant_manager_test.cpp
       copy_prop_array_test.cpp
       dead_branch_elim_test.cpp
       dead_insert_elim_test.cpp
       dead_variable_elim_test.cpp
       decoration_manager_test.cpp
       def_use_test.cpp
       eliminate_dead_const_test.cpp
       eliminate_dead_functions_test.cpp
       feature_manager_test.cpp
       flatten_decoration_test.cpp
       fold_spec_const_op_composite_test.cpp
       fold_test.cpp
       freeze_spec_const_test.cpp
       function_test.cpp
       if_conversion_test.cpp
       inline_opaque_test.cpp
       inline_test.cpp
       insert_extract_elim_test.cpp
       inst_bindless_check_test.cpp
       instruction_list_test.cpp
       instruction_test.cpp
       ir_builder.cpp
       ir_context_test.cpp
       ir_loader_test.cpp
       iterator_test.cpp
       line_debug_info_test.cpp
       local_access_chain_convert_test.cpp
       local_redundancy_elimination_test.cpp
       local_single_block_elim.cpp
       local_single_store_elim_test.cpp
       local_ssa_elim_test.cpp
       module_test.cpp
       module_utils.h
       optimizer_test.cpp
       pass_manager_test.cpp
       pass_merge_return_test.cpp
       pass_remove_duplicates_test.cpp
       pass_utils.cpp
       private_to_local_test.cpp
       process_lines_test.cpp
       propagator_test.cpp
       reduce_load_size_test.cpp
       redundancy_elimination_test.cpp
       register_liveness.cpp
       replace_invalid_opc_test.cpp
       scalar_analysis.cpp
       scalar_replacement_test.cpp
       set_spec_const_default_value_test.cpp
       simplification_test.cpp
       strength_reduction_test.cpp
       strip_debug_info_test.cpp
       strip_reflect_info_test.cpp
       struct_cfg_analysis_test.cpp
       type_manager_test.cpp
       types_test.cpp
       unify_const_test.cpp
       upgrade_memory_model_test.cpp
       utils_test.cpp pass_utils.cpp
       value_table_test.cpp
       vector_dce_test.cpp
       workaround1209_test.cpp
  LIBS SPIRV-Tools-opt
  PCH_FILE pch_test_opt
)

=== test/reduce/CMakeLists.txt ===
# Copyright (c) 2018 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

add_spvtools_unittest(TARGET reduce
        SRCS operand_to_constant_reduction_pass_test.cpp
        operand_to_undef_reduction_pass_test.cpp
        operand_to_dominating_id_reduction_pass_test.cpp
        reduce_test_util.cpp
        reduce_test_util.h
        reducer_test.cpp
        remove_opname_instruction_reduction_pass_test.cpp
        remove_unreferenced_instruction_reduction_pass_test.cpp
        structured_loop_to_selection_reduction_pass_test.cpp
        validation_during_reduction_test.cpp
        LIBS SPIRV-Tools-reduce
        )

=== test/util/CMakeLists.txt ===
# Copyright (c) 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

add_spvtools_unittest(TARGET utils
  SRCS ilist_test.cpp
       bit_vector_test.cpp
       small_vector_test.cpp
  LIBS SPIRV-Tools-opt
)

=== debian/changelog ===
spirv-tools (2019.1-2) unstable; urgency=medium

  * copyright: Updated. (Closes: #919687)

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 23 Jan 2019 14:20:46 +0200

spirv-tools (2019.1-1) unstable; urgency=medium

  * New upstream release.
  * watch: Updated.
  * fix_pkconfig_pc_file.patch: Dropped, upstream.
  * source: Switch to format 3.0 (quilt).
  * control: Bump build-dep on spirv-headers.

 -- Timo Aaltonen <tjaalton@debian.org>  Sun, 13 Jan 2019 18:46:22 +0200

spirv-tools (2018.2-1) unstable; urgency=medium

  * Initial release (Closes: #890553)

 -- Timo Aaltonen <tjaalton@debian.org>  Sun, 10 Jun 2018 10:46:15 +0300

=== debian/control ===
Source: spirv-tools
Section: libdevel
Priority: optional
Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Build-Depends: debhelper (>=10),
 cmake,
 python3-dev,
 spirv-headers (>= 1.3+git20190113-1~),
Standards-Version: 4.1.3
Homepage: https://github.com/KhronosGroup/SPIRV-Tools
Vcs-Git: https://salsa.debian.org/git/xorg-team/vulkan/spirv-tools.git
Vcs-Browser: https://salsa.debian.org/git/xorg-team/vulkan/spirv-tools.git

Package: spirv-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: API and commands for processing SPIR-V modules
 The project includes an assembler, binary module parser, disassembler,
 validator, and optimizer for SPIR-V. Except for the optimizer, all are
 based on a common static library. The library contains all of the
 implementation details, and is used in the standalone tools whilst
 also enabling integration into other code bases directly. The
 optimizer implementation resides in its own library, which depends on
 the core library.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ 

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=Release \
		-DSPIRV-Headers_SOURCE_DIR=/usr

override_dh_auto_test:

gentarball: SOURCE=spirv-tools
gentarball: UV=$(shell dpkg-parsechangelog|awk '/^Version:/ {print $$2}'|sed 's/-.*$$//')
gentarball:
	git archive --format=tar upstream-unstable --prefix=$(SOURCE)-$(UV)/ | gzip -9 > \
		../$(SOURCE)_$(UV).orig.tar.gz
